/*
 * blanco Framework
 * Copyright (C) 2004-2007 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.rss.core;

import java.io.IOException;
import java.util.logging.Logger;

import blanco.rss.core.valueobject.BlancoRss;
import blanco.rss.core.valueobject.BlancoRssItem;
import blanco.xml.bind.BlancoXmlBindingUtil;
import blanco.xml.bind.valueobject.BlancoXmlElement;

/**
 * RDFをパースして バリューオブジェクト化します。
 * 
 * @author IGA Tosiki
 */
class BlancoRssRdfParser {
    private final Logger fLog = Logger.getLogger("blanco.rss.core");

    /**
     * 与えられたエレメントをパースします。
     * 
     * @param argElementRoot
     *            ルートエレメント。
     * @return 出力バリューオブジェクト。
     * @throws IOException
     *             入出力例外が発生した場合。
     * @throws IllegalArgumentException
     *             入力例外が発生した場合。
     */
    public BlancoRss parse(final BlancoXmlElement argElementRoot)
            throws IOException, IllegalArgumentException {
        final BlancoRss outputRss = new BlancoRss();
        outputRss.setName(argElementRoot.getQName());

        for (int index = 0; index < argElementRoot.getChildNodes().size(); index++) {
            final Object objChild = argElementRoot.getChildNodes().get(index);
            if (objChild instanceof BlancoXmlElement == false) {
                continue;
            }

            final BlancoXmlElement elementChild = (BlancoXmlElement) objChild;

            if (elementChild.getQName().equals("channel")) {
                parseChannel(elementChild, outputRss);
            } else if (elementChild.getQName().equals("item")) {
                parseItem(elementChild, outputRss);
            } else {
                fLog.fine("未対応:channelとitem以外は未対応:" + elementChild.getQName());
            }
        }

        return outputRss;
    }

    /**
     * channelエレメントをパースします。
     * 
     * @param argElement
     *            channelエレメント。
     * @param argOutputRss
     *            出力バリューオブジェクト。
     */
    private void parseChannel(final BlancoXmlElement argElement,
            final BlancoRss argOutputRss) {
        for (int indexChannel = 0; indexChannel < argElement.getChildNodes()
                .size(); indexChannel++) {
            final Object objLook = argElement.getChildNodes().get(indexChannel);
            if (objLook instanceof BlancoXmlElement == false) {
                continue;
            }

            final BlancoXmlElement eleLook = (BlancoXmlElement) objLook;
            final String text = BlancoXmlBindingUtil.getTextContent(eleLook);
            if ("title".equals(eleLook.getQName())) {
                argOutputRss.getChannel().setTitle(text);
            } else if ("link".equals(eleLook.getQName())) {
                argOutputRss.getChannel().setLink(text);
            } else if ("description".equals(eleLook.getQName())) {
                argOutputRss.getChannel().setDescription(text);
            } else if ("language".equals(eleLook.getQName())) {
                argOutputRss.getChannel().setLanguage(text);
            } else if ("copyright".equals(eleLook.getQName())) {
                argOutputRss.getChannel().setCopyright(text);
            } else if ("dc:date".equals(eleLook.getQName())) {
                // TODO 実装。
                System.out.println("日付[" + text + "]");
            } else if ("items".equals(eleLook.getQName())) {
                // 無視します。
            } else {
                fLog.fine("未対応:channel[" + eleLook.getQName() + "]");
            }
        }
    }

    /**
     * itemエレメントをパースします。
     * 
     * @param argElement
     *            itemエレメント。
     * @param argOutputRss
     *            出力バリューオブジェクト。
     */
    private void parseItem(final BlancoXmlElement argElement,
            final BlancoRss argOutputRss) {
        final BlancoRssItem item = new BlancoRssItem();
        argOutputRss.getItems().add(item);

        for (int indexItem = 0; indexItem < argElement.getChildNodes().size(); indexItem++) {
            final Object objLook = argElement.getChildNodes().get(indexItem);
            if (objLook instanceof BlancoXmlElement == false) {
                continue;
            }
            final BlancoXmlElement eleLook = (BlancoXmlElement) objLook;
            final String text = BlancoXmlBindingUtil.getTextContent(eleLook);
            if ("title".equals(eleLook.getQName())) {
                item.setTitle(text);
            } else if ("link".equals(eleLook.getQName())) {
                item.setLink(text);
            } else if ("description".equals(eleLook.getQName())) {
                item.setDescription(text);
            } else if ("dc:date".equals(eleLook.getQName())) {
                // TODO 実装。
                System.out.println("日付[" + text + "]");
            } else {
                fLog.fine("未対応:item[" + eleLook.getQName() + "]");
            }
        }
    }
}
